{$A+,B-,D+,F-,G+,I-,K-,L+,N-,P-,Q-,R-,S-,T-,V-,W-,X+,Y+}
unit EWinCrt;
interface
uses {$ifdef win32}windows,messages,sysutils{$else}WinTypes,WinProcs,WinDos,win31{$endif};
const
 apptitle='Text window';
 WindowOrg:TPoint =(X:cw_UseDefault;Y:cw_UseDefault);
 WindowSize:TPoint=(X:cw_UseDefault;Y:cw_UseDefault);
 ScreenSize_x=42;
 ScreenSize_y=200;
 win_bgcolor=$00ffffff;
 Cursor:TPoint=(X:0;Y:0);
 Origin:TPoint=(X:0;Y:0);
 AutoTracking:Boolean=True;
 CrtWindow:HWnd=0;

procedure InitWinCrt;
procedure DoneWinCrt;
procedure WriteBuf(Buffer:PChar; Count:Word);
procedure WriteChar(Ch:Char);
function KeyPressed:Boolean;
function ReadKey:Char;
function ReadBuf(Buffer:PChar; Count:Word):Word;
procedure GotoXY(X,Y:Integer);
function WhereX:Integer;
function WhereY:Integer;
function Maxi(X,Y:Integer):Integer;
procedure ClrScr;
procedure ClrEol;
procedure CursorTo(X,Y:Integer);
procedure ScrollTo(X,Y:Integer);
procedure TrackCursor;
procedure AssignCrt(var F:Text);
procedure Terminate;

implementation
type
 LongRec=record
  Lo,Hi:word;
 end;
 PMinMaxInfo=^TMinMaxInfo;
 TMinMaxInfo=array[0..4] of TPoint;
 TScrollKey=record
  Key:Byte;
  Ctrl:Boolean;
  SBar:Byte;
  Action:Byte;
 end;

function CrtWinProc(Window:HWnd;Message,WParam:Word;LParam:Longint):Longint;export;forward;
const
 CrtClass:TWndClass=(
  style:cs_HRedraw+cs_VRedraw;
  lpfnWndProc:@CrtWinProc;
  cbClsExtra:0;
  cbWndExtra:0;
  hInstance:0;
  hIcon:0;
  hCursor:0;
  hbrBackground:0;
  lpszMenuName:nil;
  lpszClassName:'EWinCrt');
const
  FirstLine:Integer=0;          { First line in circular buffer }
  KeyCount:Integer=0;           { Count of keys in KeyBuffer }
  Created:Boolean=False;       	{ CRT window created? }
  Focused:Boolean=False;        { CRT window focused? }
  Reading:Boolean=False;        { Reading from CRT window? }
  Painting:Boolean=False;       { Handling wm_Paint? }

var
  ScreenBuffer:PChar;                  { Screen buffer pointer }
  ClientSize:TPoint;                   { Client area dimensions }
  Range:TPoint;                        { Scroll bar ranges }
  CharSize:TPoint;                     { Character cell size }
  CharAscent:Integer;                  { Character ascent }
  DC:HDC;                              { Global device context }
  PS:TPaintStruct;                     { Global paint structure }
  SaveFont:HFont;                      { Saved device context font }
  KeyBuffer:array[0..63] of Char;      { Keyboard type-ahead buffer }

const
  ScrollKeyCount=12;
  ScrollKeys:array[1..ScrollKeyCount] of TScrollKey=(
    (Key:vk_Left;  Ctrl:True; SBar:sb_Horz; Action:sb_LineUp),
    (Key:vk_Right; Ctrl:True; SBar:sb_Horz; Action:sb_LineDown),
    (Key:vk_Left;  Ctrl:True;  SBar:sb_Horz; Action:sb_PageUp),
    (Key:vk_Right; Ctrl:True;  SBar:sb_Horz; Action:sb_PageDown),
    (Key:vk_Home;  Ctrl:False; SBar:sb_Horz; Action:sb_Top),
    (Key:vk_End;   Ctrl:False; SBar:sb_Horz; Action:sb_Bottom),
    (Key:vk_Up;    Ctrl:False; SBar:sb_Vert; Action:sb_LineUp),
    (Key:vk_Down;  Ctrl:False; SBar:sb_Vert; Action:sb_LineDown),
    (Key:vk_Prior; Ctrl:False; SBar:sb_Vert; Action:sb_PageUp),
    (Key:vk_Next;  Ctrl:False; SBar:sb_Vert; Action:sb_PageDown),
    (Key:vk_Home;  Ctrl:True;  SBar:sb_Vert; Action:sb_Top),
    (Key:vk_End;   Ctrl:True;  SBar:sb_Vert; Action:sb_Bottom));

function Minl(X,Y:Longint):Longint;
begin
 if X<Y then Minl:=X else Minl:=Y;
end;

function Maxl(X,Y:Longint):Longint;
begin
 if X>Y then Maxl:=X else Maxl:=Y;
end;

function Mini(X,Y:Integer):Integer;
begin
 if X<Y then Mini:=X else Mini:=Y;
end;

function Maxi(X,Y:Integer):Integer;
begin
 if X>Y then Maxi:=X else Maxi:=Y;
end;

procedure InitDeviceContext;
begin
 if Painting then DC:=BeginPaint(CrtWindow,PS)
  else DC:=GetDC(CrtWindow);
 SaveFont:=SelectObject(DC,GetStockObject(System_Fixed_Font));
end;

procedure DoneDeviceContext;
begin
 SelectObject(DC,SaveFont);
 if Painting then EndPaint(CrtWindow,PS)
  else ReleaseDC(CrtWindow,DC);
end;

procedure ShowCursor;
begin
 CreateCaret(CrtWindow,0,CharSize.X,2);
 SetCaretPos((Cursor.X-Origin.X)*CharSize.X,(Cursor.Y-Origin.Y)*CharSize.Y+CharAscent+2);
 ShowCaret(CrtWindow);
end;

procedure SetScrollBars;
begin
  SetScrollRange(CrtWindow,sb_Horz,0,Maxi(1,Range.X),False);
  SetScrollPos(CrtWindow,sb_Horz,Origin.X,True);
  SetScrollRange(CrtWindow,sb_Vert,0,Maxi(1,Range.Y),False);
  SetScrollPos(CrtWindow,sb_Vert,Origin.Y,True);
end;

procedure Terminate;
begin
  if Focused and Reading then DestroyCaret;
  Halt;
end;

procedure CursorTo(X,Y:Integer);
begin
  Cursor.X:=Maxi(0,Mini(X,ScreenSize_X-1));
  Cursor.Y:=Maxi(0,Mini(Y,ScreenSize_Y-1));
end;

procedure ScrollTo(X,Y:Integer);
begin
  if Created then
  begin
    X:=Maxi(0,Mini(X,Range.X));
    Y:=Maxi(0,Mini(Y,Range.Y));
    if (X <> Origin.X) or (Y <> Origin.Y) then
    begin
      if X <> Origin.X then SetScrollPos(CrtWindow,sb_Horz,X,True);
      if Y <> Origin.Y then SetScrollPos(CrtWindow,sb_Vert,Y,True);
      ScrollWindow(CrtWindow,
	(Origin.X-X)*CharSize.X,
	(Origin.Y-Y)*CharSize.Y,nil,nil);
      Origin.X:=X;
      Origin.Y:=Y;
      UpdateWindow(CrtWindow);
    end;
  end;
end;

procedure TrackCursor;
begin
  ScrollTo(Maxi(Cursor.X-ClientSize.X+1,Mini(Origin.X,Cursor.X)),
    Maxi(Cursor.Y-ClientSize.Y+1,Mini(Origin.Y,Cursor.Y)));
end;

function ScreenPtr(X,Y:Integer):PChar;
begin
  Inc(Y,FirstLine);
  if Y >= ScreenSize_Y then Dec(Y,ScreenSize_Y);
  ScreenPtr:=@ScreenBuffer[Y*ScreenSize_X+X];
end;

procedure ShowText(L,R:Integer);
begin
  if L<R then
  begin
    InitDeviceContext;
    TextOut(DC,(L-Origin.X)*CharSize.X,
      (Cursor.Y-Origin.Y)*CharSize.Y,
      ScreenPtr(L,Cursor.Y),R-L);
    DoneDeviceContext;
  end;
end;

procedure WriteBuf(Buffer:PChar; Count:Word);
var
 y,l,r:integer;
procedure NewLine;
begin
 ShowText(L,R);
 L:=0;
 R:=0;
 Cursor.X:=0;
 Inc(Cursor.Y);
 if Cursor.Y=ScreenSize_Y then
 begin
  Dec(Cursor.Y);
  Inc(FirstLine);
  if FirstLine=ScreenSize_Y then FirstLine:=0;
  FillChar(ScreenPtr(0,Cursor.Y)^,ScreenSize_X,' ');
  ScrollWindow(CrtWindow,0,-CharSize.Y,nil,nil);
  UpdateWindow(CrtWindow);
 end;
end;

begin
  L:=Cursor.X;
  R:=Cursor.X;
  while Count > 0 do
  begin
   case Buffer^ of
    #13:NewLine;
    #10:;
    else begin
     y:=cursor.y+FirstLine;
     if Y>=ScreenSize_Y then Dec(Y,ScreenSize_Y);
     ScreenBuffer[Y*ScreenSize_X+Cursor.X]:=Buffer^;
     Inc(Cursor.X);
     if Cursor.X>R then R:=Cursor.X;
     if Cursor.X=ScreenSize_X then NewLine;
    end;
   end;
   Inc(Buffer);
   Dec(Count);
  end;
  ShowText(L,R);
  if AutoTracking then TrackCursor;
end;

procedure WriteChar(Ch:Char);
begin
  WriteBuf(@Ch,1);
end;

function KeyPressed:Boolean;
var
  M:TMsg;
begin
  while PeekMessage(M,0,0,0,pm_Remove) do
  begin
    if M.Message=wm_Quit then Terminate;
    TranslateMessage(M);
    DispatchMessage(M);
  end;
  KeyPressed:=KeyCount > 0;
end;

function ReadKey:Char;
begin
  TrackCursor;
  if not KeyPressed then
  begin
    Reading:=True;
    if Focused then ShowCursor;
    repeat until KeyPressed;
    if Focused then DestroyCaret;
    Reading:=False;
  end;
  ReadKey:=KeyBuffer[0];
  Dec(KeyCount);
  Move(KeyBuffer[1],KeyBuffer[0],KeyCount);
end;

function ReadBuf(Buffer:PChar; Count:Word):Word;
var
  Ch:Char;
  I:Word;
begin
  I:=0;
  repeat
    Ch:=ReadKey;
    case Ch of
      #8:
	if I > 0 then
	begin
	  Dec(I);
	  WriteChar(#8);
	end;
      #32..#255:
	if I<Count-2 then
	begin
	  Buffer[I]:=Ch;
	  Inc(I);
	  WriteChar(Ch);
	end;
    end;
  until (Ch=#13);
  Buffer[I]:=Ch;
  Inc(I);
  if Ch=#13 then
  begin
    Buffer[I]:=#10;
    Inc(I);
    WriteChar(#13);
  end;
  TrackCursor;
  ReadBuf:=I;
end;

procedure GotoXY(X,Y:Integer);
begin
  CursorTo(X-1,Y-1);
end;

function WhereX:Integer;
begin
  WhereX:=Cursor.X+1;
end;

function WhereY:Integer;
begin
  WhereY:=Cursor.Y+1;
end;

procedure ClrScr;
begin
  FillChar(ScreenBuffer^,ScreenSize_X*ScreenSize_Y,' ');
  fillchar(Cursor,sizeof(cursor),0);
  fillchar(origin,sizeof(origin),0);
  SetScrollBars;
  InvalidateRect(CrtWindow,nil,True);
  UpdateWindow(CrtWindow);
end;

procedure ClrEol;
begin
  FillChar(ScreenPtr(Cursor.X,Cursor.Y)^,ScreenSize_X-Cursor.X,' ');
  ShowText(Cursor.X,ScreenSize_X);
end;

procedure WindowCreate;
begin
  Created:=True;
  GetMem(ScreenBuffer,ScreenSize_X*ScreenSize_Y);
  FillChar(ScreenBuffer^,ScreenSize_X*ScreenSize_Y,' ');
end;

procedure WindowPaint;
var
  X1,X2,Y1,Y2:Longint;
begin
  Painting:=True;
  InitDeviceContext;
  X1:=Maxl(0,PS.rcPaint.left div CharSize.X+Origin.X);
  X2:=Minl(ScreenSize_X,
    (PS.rcPaint.right+CharSize.X-1) div CharSize.X+Origin.X);
  Y1:=Maxl(0,PS.rcPaint.top div CharSize.Y+Origin.Y);
  Y2:=Minl(ScreenSize_Y,
    (PS.rcPaint.bottom+CharSize.Y-1) div CharSize.Y+Origin.Y);
  while Y1<Y2 do
  begin
    TextOut(DC,(X1-Origin.X)*CharSize.X,(Y1-Origin.Y)*CharSize.Y,
      ScreenPtr(X1,Y1),X2-X1);
    Inc(Y1);
  end;
  DoneDeviceContext;
  Painting:=False;
end;

procedure WindowScroll(Which,Action,Thumb:Integer);
var
  X,Y:integer;

function GetNewPos(Pos,Page,Range:Longint):integer;
begin
  case Action of
    sb_LineUp:GetNewPos:=Pos-1;
    sb_LineDown:GetNewPos:=Pos+1;
    sb_PageUp:GetNewPos:=Pos-Page;
    sb_PageDown:GetNewPos:=Pos+Page;
    sb_Top:GetNewPos:=0;
    sb_Bottom:GetNewPos:=Range;
    sb_ThumbPosition:GetNewPos:=Thumb;
  else
    GetNewPos:=Pos;
  end;
end;

begin
  X:=Origin.X;
  Y:=Origin.Y;
  case Which of
    sb_Horz:X:=GetNewPos(X,ClientSize.X div 2,Range.X);
    sb_Vert:Y:=GetNewPos(Y,ClientSize.Y,Range.Y);
  end;
  ScrollTo(X,Y);
end;

procedure WindowResize(X,Y:integer);
begin
  if Focused and Reading then DestroyCaret;
  ClientSize.X:=X div CharSize.X;
  ClientSize.Y:=Y div CharSize.Y;
  Range.X:=Maxi(0,ScreenSize_X-ClientSize.X);
  Range.Y:=Maxi(0,ScreenSize_Y-ClientSize.Y);
  Origin.X:=Mini(Origin.X,Range.X);
  Origin.Y:=Mini(Origin.Y,Range.Y);
  SetScrollBars;
  if Focused and Reading then ShowCursor;
end;

procedure WindowMinMaxInfo(MinMaxInfo:PMinMaxInfo);
var
  X,Y:Longint;
  Metrics:TTextMetric;
begin
  InitDeviceContext;
  GetTextMetrics(DC,Metrics);
  CharSize.X:=Metrics.tmAveCharWidth;
  CharSize.Y:=Metrics.tmHeight+Metrics.tmExternalLeading;
  CharAscent:=Metrics.tmAscent;
  X:=Minl(ScreenSize_X*CharSize.X+GetSystemMetrics(sm_CXVScroll),
    GetSystemMetrics(sm_CXScreen))+GetSystemMetrics(sm_CXFrame)*2;
  Y:=Minl(ScreenSize_Y*CharSize.Y+GetSystemMetrics(sm_CYHScroll) +
    GetSystemMetrics(sm_CYCaption),GetSystemMetrics(sm_CYScreen))+
    GetSystemMetrics(sm_CYFrame)*2;
  MinMaxInfo^[1].x:=X;
  MinMaxInfo^[1].y:=Y;
  MinMaxInfo^[3].x:=CharSize.X*16+GetSystemMetrics(sm_CXVScroll) +
    GetSystemMetrics(sm_CXFrame)*2;
  MinMaxInfo^[3].y:=CharSize.Y*4+GetSystemMetrics(sm_CYHScroll) +
    GetSystemMetrics(sm_CYFrame)*2+GetSystemMetrics(sm_CYCaption);
  MinMaxInfo^[4].x:=X;
  MinMaxInfo^[4].y:=Y;
  DoneDeviceContext;
end;

procedure WindowChar(Ch:Char);
begin
  if KeyCount<SizeOf(KeyBuffer) then
  begin
    KeyBuffer[KeyCount]:=Ch;
    Inc(KeyCount);
  end;
end;

procedure specadd(b:char);
begin
 if KeyCount<SizeOf(KeyBuffer)-1 then
 begin
  KeyBuffer[KeyCount]:=#0;
  KeyBuffer[KeyCount+1]:=b;
  Inc(KeyCount,2);
 end;
end;

procedure WindowKeyDown(KeyDown:Byte);
var
  ShitDown,CtrlDown:Boolean;
  I:Longint;
begin
  CtrlDown:=GetKeyState(vk_Control)<0;
  ShitDown:=GetKeyState(vk_Shift)<0;
  if shitdown then begin
   case keydown of
    vk_insert,vk_numpad0:begin
     specadd(#1);
     exit;
    end;
   end;
  end;
  for I:=1 to ScrollKeyCount do
  with ScrollKeys[I] do
  if (Key=KeyDown) and (Ctrl=CtrlDown) then
  begin
   WindowScroll(SBar,Action,0);
   Exit;
  end;
end;

procedure WindowSetFocus;
begin
  Focused:=True;
  if Reading then ShowCursor;
end;

procedure WindowKillFocus;
begin
  if Reading then DestroyCaret;
  Focused:=False;
end;

procedure WindowDestroy;
begin
  FreeMem(ScreenBuffer,ScreenSize_X*ScreenSize_Y);
  fillchar(Cursor,sizeof(cursor),0);
  fillchar(origin,sizeof(origin),0);
{  PostQuitMessage(0);}
  Created:=False;
  Terminate;
end;

function CrtWinProc(Window:HWnd; Message,WParam:Word;
  LParam:Longint):Longint;
begin
  CrtWinProc:=0;
  CrtWindow:=Window;
  case Message of
    wm_Create:WindowCreate;
    wm_Paint:WindowPaint;
    wm_VScroll:WindowScroll(sb_Vert,WParam,LongRec(LParam).Lo);
    wm_HScroll:WindowScroll(sb_Horz,WParam,LongRec(LParam).Lo);
    wm_Size:WindowResize(LongRec(LParam).Lo,LongRec(LParam).Hi);
    wm_GetMinMaxInfo:WindowMinMaxInfo(PMinMaxInfo(LParam));
    wm_Char:WindowChar(Char(WParam));
    wm_KeyDown:WindowKeyDown(Byte(WParam));
    wm_SetFocus:WindowSetFocus;
    wm_KillFocus:WindowKillFocus;
    wm_Destroy:WindowDestroy;
  else
    CrtWinProc:=DefWindowProc(Window,Message,WParam,LParam);
  end;
end;

function CrtOutput(var F:TTextRec):Integer; far;
begin
  if F.BufPos <> 0 then
  begin
    WriteBuf(PChar(F.BufPtr),F.BufPos);
    F.BufPos:=0;
    KeyPressed;
  end;
  CrtOutput:=0;
end;

function CrtInput(var F:TTextRec):Integer; far;
begin
  F.BufEnd:=ReadBuf(PChar(F.BufPtr),F.BufSize);
  F.BufPos:=0;
  CrtInput:=0;
end;

function CrtClose(var F:TTextRec):Integer; far;
begin
  CrtClose:=0;
end;

function CrtOpen(var F:TTextRec):Integer; far;
begin
  if F.Mode=fmInput then
  begin
    F.InOutFunc:=@CrtInput;
    F.FlushFunc:=nil;
  end else
  begin
    F.Mode:=fmOutput;
    F.InOutFunc:=@CrtOutput;
    F.FlushFunc:=@CrtOutput;
  end;
  F.CloseFunc:=@CrtClose;
  CrtOpen:=0;
end;

procedure AssignCrt(var F:Text);
begin
  with TTextRec(F) do
  begin
    Handle:=$FFFF;
    Mode:=fmClosed;
    BufSize:=SizeOf(Buffer);
    BufPtr:=@Buffer;
    OpenFunc:=@CrtOpen;
    Name[0]:=#0;
  end;
end;

procedure InitWinCrt;
begin
  if not Created then
  begin
    CrtWindow:=CreateWindow(
      CrtClass.lpszClassName,
      apptitle,
      ws_OverlappedWindow+ws_HScroll+ws_VScroll,
      WindowOrg.X,WindowOrg.Y,
      WindowSize.X,WindowSize.Y,
      0,
      0,
      HInstance,
      nil);
    ShowWindow(CrtWindow,10{SW_SHOWDEFAULT});
    UpdateWindow(CrtWindow);
  end;
end;

procedure DoneWinCrt;
begin
  if Created then DestroyWindow(CrtWindow);
  Halt(0);
end;

begin
 if HPrevInst=0 then
 begin
  CrtClass.hInstance:=HInstance;
  CrtClass.hIcon:=LoadIcon(0,idi_Exclamation);
  CrtClass.hCursor:=LoadCursor(0,idc_Arrow);
  CrtClass.hbrBackground:=CreateSolidBrush(win_bgcolor{Color_Appworkspace});
  RegisterClass(CrtClass);
 end;
 AssignCrt(Input);
 Reset(Input);
 AssignCrt(Output);
 Rewrite(Output);
 initwincrt;
end.
